<?php
class Dashboard{
	function __construct(){ add_action('admin_menu', array($this, 'SettingsMenuAdmin') ); }
	function my_plugin_admin_styles() {	wp_enqueue_style( 'myPluginStylesheet', PLUGIN_PATH_CSS ); }

	// modification du menu
	function SettingsMenuAdmin(){
		// juste pour l'administrateur (ceux qui peuvent changer les options)
		add_menu_page('Gestion', 'Mon groupe', 'manage_options', 'stats-menu', array($this, 'pageIndex'), FAVICONGROUPE);
		add_submenu_page('stats-menu', 'Analyse lexicale', 'Analyse lexicale', 'manage_options', 'stats-menu-lexique', array($this, 'pageLexique') );
		// pour les auteurs aussi (ceux qui peuvent publier des articles)
		add_menu_page('Mes statistiques', 'Mes statistiques', 'publish_posts', 'stats-menu-eleve', array($this, 'pageEleve'), FAVICONELEVE);
		add_submenu_page('stats-menu-eleve', 'Analyse lexicale', 'Analyse lexicale', 'publish_posts', 'stats-menu-lexique-eleve', array($this, 'pageEleveLexique') );		
	}

	// page index, appelée par la fonction add_menu_page dans SettingsMenuAdmin() et qu'on peut consulter en allant dans Satistiques / Statistiques
	function pageIndex(){
		$this->init_admin_pages();	

		// fonction init (JavaScript) définie dans script/main.js : l'url du xml des articles et le nom du bouton qui génère les statistiques
		?>
		<script>
		jQuery(document).ready(function(){
			init(xmlpatharticles, 'updateStats');
		});
		</script>
		<?php
		// afficher le html, le paramètre est le nom du bouton de mise à jour des statistiques, associé à la fonction updateStats dans script/stats.js
		$this->affichehtml('updateStats');
	}

	// page lexique, appelée par la fonction add_submenu_page dans SettingsMenuAdmin() et qu'on peut consulter en allant dans Satistiques / Analyse lexicale
	function pageLexique(){
		$this->init_admin_pages();	

		// fonction init (JavaScript) définie dans script/main.js : l'url du xml du lexique et le nom du bouton qui génère les statistiques d'utilisation du dictionnaire
		?>
		<script>
		jQuery(document).ready(function(){
			init(xmlpathlexique, 'updateLexique');
		});
		</script>
		<?php
		// afficher le html, le paramètre est le nom du bouton de mise à jour des statistiques, associé à la fonction updateLexique dans script/lexique.js
		$this->affichehtml('updateLexique');
	}

	function pageEleve(){
		$this->init_author_pages();	

		// fonction init (JavaScript) définie dans script/main.js : l'url du xml des articles et le nom du bouton qui génère les statistiques
		?>
		<script>
		jQuery(document).ready(function(){
			tritag = 'nbarticles'; // le tri se fait par nombre d'article (et ne peut être changé)
			triordre = 'desc'; // le tri se fait en ordre décroissant
			tritype = 'number'; // les données sont traitées en nombre
			triattr = 'total'; // la donnée est stockée dans l'attribut total de l'élément nbarticles

			init(xmlpatharticles, 'updateStats');

		});
		</script>
		<?php
		// afficher le html, le paramètre est le nom du bouton de mise à jour des statistiques, associé à la fonction updateStats dans script/stats.js
		$this->affichehtmleleve('updateStats');
	}	

	function pageEleveLexique(){
		$this->init_author_pages();	

		// fonction init (JavaScript) définie dans script/main.js : l'url du xml des articles et le nom du bouton qui génère les statistiques
		?>
		<script>
		jQuery(document).ready(function(){
			tritag = 'tous'; // le tri se fait par nombre de mots du dictionnaire utilisés (et ne peut être changé)
			triordre = 'desc'; // le tri se fait en ordre décroissant
			tritype = 'number'; // les données sont traitées en nombre
			triattr = 'nb'; // la donnée est stockée dans l'attribut nb de l'élément tous

			init(xmlpathlexique, 'updateLexique');

		});
		</script>
		<?php
		// afficher le html, le paramètre est le nom du bouton de mise à jour des statistiques, associé à la fonction updateStats dans script/stats.js
		$this->affichehtmleleve('updateLexique');
	}

	// ajoute le css et les scripts propres à ce plugin pour les pages vues par l'administrateur
	// passe les valeurs contenues dans les constantes définies dans ../index.php dans les scripts 
	private function init_admin_pages(){
		wp_enqueue_style('style-name', PLUGIN_PATH_CSS);
		wp_enqueue_script('graph', PLUGIN_PATH_JS_GRAPH); 
		wp_enqueue_script('main', PLUGIN_PATH_JS_MAIN);
		wp_enqueue_script('stats', PLUGIN_PATH_JS_STATS);
		wp_enqueue_script('lexique', PLUGIN_PATH_JS_LEXIQUE);
		
		wp_register_script('jquery', "http" . ($_SERVER['SERVER_PORT'] == 443 ? "s" : "") . "://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js", false, null);
		wp_register_script('jqueryui', "http" . ($_SERVER['SERVER_PORT'] == 443 ? "s" : "") . "://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js", false, null);
		wp_enqueue_script('jquery');		
		wp_enqueue_script('jqueryui');
		?>
		<script>
			xmlpatharticles = "<?php echo PLUGIN_PATH_XML_ART ?>";
			xmlpathlexique = "<?php echo PLUGIN_PATH_XML_LEX ?>";
			xmldictionnaire = "<?php echo PLUGIN_PATH_XML_DIC ?>";
			dictionnaire = "<?php echo PLUGIN_PATH_DIC ?>";
			imgpath = "<?php echo PLUGIN_PATH_IMG ?>";
		</script>
		<?php
	}

	// ajoute le css et les scripts propres à ce plugin pour les pages vues par les élèves
	// passe les valeurs contenues dans les constantes définies dans ../index.php dans les scripts 
	private function init_author_pages(){
		wp_enqueue_style('style-name', PLUGIN_PATH_CSS);
		wp_enqueue_script('graph', PLUGIN_PATH_JS_GRAPH); 
		wp_enqueue_script('main', PLUGIN_PATH_JS_MAIN);
		wp_enqueue_script('stats', PLUGIN_PATH_JS_STATSELEVES);
		wp_enqueue_script('lexique', PLUGIN_PATH_JS_LEXIQUEELEVES);
		
		wp_register_script('jquery', "http" . ($_SERVER['SERVER_PORT'] == 443 ? "s" : "") . "://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js", false, null);
		wp_register_script('jqueryui', "http" . ($_SERVER['SERVER_PORT'] == 443 ? "s" : "") . "://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js", false, null);
		wp_enqueue_script('jquery');		
		wp_enqueue_script('jqueryui');

		global $current_user;
      	get_currentuserinfo();
		?>
		<script>
			xmlpatharticles = "<?php echo PLUGIN_PATH_XML_ART ?>";
			xmlpathlexique = "<?php echo PLUGIN_PATH_XML_LEX ?>";
			xmldictionnaire = "<?php echo PLUGIN_PATH_XML_DIC ?>";
			dictionnaire = "<?php echo PLUGIN_PATH_DIC ?>";
			imgpath = "<?php echo PLUGIN_PATH_IMG ?>";
			current = "<?php echo $current_user->user_login ?>";
		</script>
		<?php
	}

	// affichage de l'interface des pages index (statistiques) et lexique (analyse lexicale) vues par l'administrateur
	private function affichehtml($update){
		?>
		<div class="wrap">
			<div class="clearfix" id="filtres">
				<div class="filtre">
					<h2><button class="showhide">Afficher</button>Par élève</h2>
					
					<ul>
						<li><label><input type="checkbox" id="tousauteurs" checked="checked">Tous les auteurs</label></li>
					</ul>
					<ul id="auteurs">
					<?php
						$args  = array(
							'role' => 'Author',
							'orderby' => 'display_name'
						);

						$wp_user_query = new WP_User_Query($args);
						$authors = $wp_user_query->get_results();

						if (!empty($authors)){
						   	$tart = 0;
						    $tcom = 0;
						    $nb = count($authors);

						    foreach ($authors as $author){
						        $author_info = get_userdata($author->ID);
						        $id = $author->ID;
						        $nom = "$author_info->first_name $author_info->last_name";
						        $login = $author_info->user_login;
						        ?>
						        <li>
						        	<label><input type="checkbox" id="<?php echo $id ?>" checked="checked"><?php echo "$nom"; ?></label>
						        </li>
						        <?php
						    }
						} 
						else {
						    echo '<li>Aucun élève trouvé</li>';
						}

					    ?>
					</ul>
				</div>

				<div class="filtre">
					<h2><button class="showhide">Afficher</button>Par date</h2>
					<ul>
						<li><label><input type="checkbox" id="toutesdates" checked="checked">Tous les dates</label></li>
					</ul>
					<ul id="date">
						<li><label for="debut">Début : </label><input type="text" id="debut" disabled="disabled"></li>
						<li><label for="fin">Fin : </label><input type="text" id="fin" disabled="disabled"></li>
						<li><input type="radio" id="sansgroupe" name="periode" disabled="disabled" checked="checked"><label for="sansgroupe" class="inactif">Sans&nbsp;regroupement</label></li>
						<li><input type="radio" id="annuel" name="periode" disabled="disabled"><label for="annuel" class="inactif">Annuel</label></li>
						<li><input type="radio" id="mensuel" name="periode" disabled="disabled"><label for="mensuel" class="inactif">Mensuel</label></li>
						<li><input type="radio" id="hebdo" name="periode" disabled="disabled"><label for="hebdo" class="inactif">Hebdomadaire</label></li>
					</ul>
				</div>

				<div class="filtre maj">
					<input type="checkbox" id="tableau" checked="checked"><label for="tableau">Tableau</label> 
					<input type="checkbox" id="graphique" checked="checked"><label for="graphique">Graphique</label>
					<input type="checkbox" id="affichernoms" checked="checked"><label for="affichernoms">Afficher les noms</label>
					<br>
					<button id="<?php echo $update; ?>" disabled>Chargement des données...</button>
				</div>


			</div><!--clearfix-->

			<div id="resultats"></div>
			<div id="resgraphique"></div>
		</div>
		<?php
	}

	// affichage de l'interface des pages index (statistiques) et lexique (analyse lexicale) vues par les élèves
	private function affichehtmleleve($update){
		?>
		<div class="wrap">
			<div class="clearfix" id="filtres">

				<div class="filtre">
					<h2><button class="showhide">Afficher</button>Par date</h2>
					<ul>
						<li><label><input type="checkbox" id="toutesdates" checked="checked">Tous les dates</label></li>
					</ul>
					<ul id="date">
						<li><label for="debut">Début : </label><input type="text" id="debut" disabled="disabled"></li>
						<li><label for="fin">Fin : </label><input type="text" id="fin" disabled="disabled"></li>
						<li><input type="radio" id="sansgroupe" name="periode" disabled="disabled" checked="checked"><label for="sansgroupe" class="inactif">Sans&nbsp;regroupement</label></li>
						<li><input type="radio" id="annuel" name="periode" disabled="disabled"><label for="annuel" class="inactif">Annuel</label></li>
						<li><input type="radio" id="mensuel" name="periode" disabled="disabled"><label for="mensuel" class="inactif">Mensuel</label></li>
						<li><input type="radio" id="hebdo" name="periode" disabled="disabled"><label for="hebdo" class="inactif">Hebdomadaire</label></li>
					</ul>
				</div>

				<div class="filtre maj">
					<input type="checkbox" id="tableau" checked="checked"><label for="tableau">Tableau</label> 
					<input type="checkbox" id="graphique" checked="checked"><label for="graphique">Graphique</label>
					<br>
					<button id="<?php echo $update; ?>" disabled>Chargement des données...</button>
				</div>


			</div><!--clearfix-->

			<div id="resultats"></div>
			<div id="resgraphique"></div>
		</div>
		<?php
	}

}