<?php

/********************************************************************************************************************************************************/
/*                                                                                                                                                      */
/*                                                     XML LEXIQUE                                                                                      */
/*                                                                                                                                                      */
/********************************************************************************************************************************************************/


/***********************************************************************************/
/*  Le xml généré à partir des articles dans Wordpress a le format suivant         */
/*  et il peut être consulté à la page :                                           */
/*  http://localhost/wpsev/wp-content/plugins/affordance/inc/xmllexique.php        */
/*  <stats_articles>                                                               */
/*  	<article id="">                                                            */
/*  		<auteur id="">                                                         */
/*  			<nom></nom>                                                        */
/*  			<prenom></prenom>                                                  */
/*  			<nomutilisateur></nomutilisateur>                                  */
/*  		</auteur>                                                              */
/*  		<datepub valeur="">                                                    */
/*  			<texte></texte>                                                    */
/*  			<semaine></semaine>                                                */
/*  			<mois></mois>                                                      */
/*  			<annee></annee>                                                    */
/*  		</datepub>                                                             */
/*  		<titre></titre>                                                        */
/*  		<contenu></contenu>                                                    */
/*  	</article>                                                                 */
/*  </stats_articles>                                                              */
/***********************************************************************************/


define('WP_USE_THEMES', false);
require_once('../../../../wp-blog-header.php');
date_default_timezone_set('America/Montreal');

$args  = array(
	'role' => 'Author',
	'orderby' => 'id'
);

$wp_user_query = new WP_User_Query($args);
$authors = $wp_user_query->get_results();
$aut = array();
foreach ($authors as $a) {
	$aut[$a->ID] = array('prenom' => $a->first_name, 'nom' => $a->last_name, 'login' => $a->user_login);
}

$q = new WP_Query('nopaging=true');
$dico = array_flip(file(plugins_url('../dictionnaire/microlaroussebonifie.txt', __FILE__), FILE_IGNORE_NEW_LINES));

		$xml = '<stats_articles>';
		foreach ($q->posts as $p) {
			$pid = $p->ID;
			$auteur = $p->post_author;
			$dt = $p->post_date;
			$ddt = mktime(0, 0, 0, substr($dt, 5, 2), substr($dt, 8, 2), substr($dt, 0, 4));
			$dttexte = date('Y-m-d', $ddt);
			$dtannee = date('Y', $ddt);
			$dtmois = date('n', $ddt);
			$lundi = date('Y-m-d', lundi($ddt));

			$prenom = $aut[$auteur]['prenom'];
			$nom = $aut[$auteur]['nom'];
			$login = $aut[$auteur]['login'];
			$contenu = str_replace('& ', '&amp;', str_replace('&nbsp;', ' ', strip_tags($p->post_content)));
			$mots = getTag($contenu);

			if (!empty($login)){
				$xml .= "
		<article id=\"$pid\">
			<auteur id=\"$auteur\">
				<nom>$nom</nom>
				<prenom>$prenom</prenom>
				<nomutilisateur>$login</nomutilisateur>
			</auteur>
			<datepub valeur=\"$dt\">
				<texte>$dttexte</texte>
				<semaine>$lundi</semaine>
				<mois>$dtannee-$dtmois</mois>
				<annee>$dtannee</annee>
			</datepub>
			<contenu>$mots</contenu>
		</article>";
			}
		}
		$xml .= '
</stats_articles>';
echo $xml;

function lundi($dt){
	$dt = $dt - ((int)(date('N', $dt)) - 1) * 86400;
	return $dt;
}

function getTag($txt){
	global $dico;

	$t = strtolower(preg_replace('/[^A-Za-zÀÂÄÇÉÈÊËÎÏÔÖÙÛÜàâäéèêëîïôöùûü]/u', ' ', $txt));
	$contenu = explode(' ', $t);

	$inter = array();
	foreach ($contenu as $mot){
        if (isset($dico[$mot])){
        	$inter[$mot] = $mot;
        }
    }
	return implode(' ', $inter);
}


?>