/********************************************************************************************************************************************************/
/*                                                                                                                                                      */
/*                                                     VARIABLES GLOBALES                                                                               */
/*                                                                                                                                                      */
/********************************************************************************************************************************************************/

xmlarticles = ''; // contient le xml pour générer le tableau et le graphique
tritag = 'nom'; // le tri se fait par nom d'utilisateur par défaut
triordre = 'asc'; // le tri se fait en ordre alphabétique par défaut
tritype = 'text'; // les données sont traitées en texte
triattr = false; // le nom, utilisé pour le tri, n'est pas continu dans un attribut d'un élément mais dans un élément

datatypes = new Array(); // associe toutes les balises de tri possibles à leur type de données à tirer (text ou number)
datatypes['nom'] = 'text'; 
datatypes['prenom'] = 'text';
datatypes['nomutilisateur'] = 'text';
datatypes['nbarticles'] = 'number';
datatypes['tous'] = 'number';

attr = new Array(); // associe le nom du tri à l'attribut qui contient la valeur à trier. Pas d'attribut : on stock ''
attr['nom'] = ''; 
attr['prenom'] = '';
attr['nomutilisateur'] = '';
attr['nbarticles'] = 'total';
attr['tous'] = 'nb';

// pour afficher les mois dans le tableau
arrmois = new Array('Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Aout', 'Septembre', 'Octobre', 'Novembre', 'Décembre');
arrmoiscourts = new Array('jan', 'fév', 'mar', 'avr', 'mai', 'jun', 'jui', 'aou', 'sep', 'oct', 'nov', 'déc');

// utilisée pour les totaux dans les tableaux
totaltout = 0;
totalannee = new Array();
totalmois = new Array();
totalsemaine = new Array();



/********************************************************************************************************************************************************/
/*                                                                                                                                                      */
/*                                                     TOUTES LES PAGES                                                                                 */
/*                                                                                                                                                      */
/********************************************************************************************************************************************************/


/***********************************************************************************/
/* Fonction : 	init                                                               */
/* Paramètres : page - url du xml selon la page, défini dans dashboard.php         */
/*				updatename - le nom du bouton qui génère les statistiques          */
/* Retour : 	aucun                                                              */
/* Rôle : 		initalisations pour la page de stats et la page de lexique :       */
/*              requête ajax pour le xml de lexique généré (inc/xmllexiques.php ou */
/*              inc/xmlarticles.php) et initialisation des contrôles pour les      */
/*              filtres dans la page de lexique                                    */
/***********************************************************************************/

function init(page, updatename){

	jQuery.ajax({
		type: "POST",
		url: page, 
		dataType: "xml",
		success: function(retour) {	 	
			xmlarticles = retour;
			// prêt pour générer les statistiques!
			jQuery('#' + updatename).removeAttr('disabled').html('Générer les statistiques');
			jQuery('#resultats').css('background', 'none');
		},
		error: function(e, s){
			console.log(s)
		}

	});

	// controles pour les champs de date
	jQuery.datepicker.regional['fr'] = {clearText: 'Effacer', clearStatus: '', closeText: 'Fermer', closeStatus: 'Fermer sans modifier', prevText: '&lt;Préc', prevStatus: 'Voir le mois précédent', nextText: 'Suiv&gt;', nextStatus: 'Voir le mois suivant', currentText: 'Courant', currentStatus: 'Voir le mois courant', monthNames: ['Janvier','Février','Mars','Avril','Mai','Juin', 'Juillet','Août','Septembre','Octobre','Novembre','Décembre'], monthNamesShort: ['Jan','Fév','Mar','Avr','Mai','Jun', 'Jul','Aoû','Sep','Oct','Nov','Déc'], monthStatus: 'Voir un autre mois', yearStatus: 'Voir un autre année', weekHeader: 'Sm', weekStatus: '', dayNames: ['Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'], dayNamesShort: ['Dim','Lun','Mar','Mer','Jeu','Ven','Sam'], dayNamesMin: ['Di','Lu','Ma','Me','Je','Ve','Sa'], dayStatus: 'Utiliser DD comme premier jour de la semaine', dateStatus: 'Choisir le DD, MM d', dateFormat: 'yy-mm-dd', firstDay: 0, initStatus: 'Choisir la date', isRTL: false};
	jQuery.datepicker.setDefaults(jQuery.datepicker.regional['fr']);
	
	// définition des valeurs de début et de fin à mettre dans les champs par défaut, en fonction de l'année scolaire au primaire et au secondaire
	// si on est entre juillet et décembre, c'est du premier juillet de l'année courante jusqu'au 30 juin de l'année suivante
	// si on est entre janvier et juin, c'est du premier juillet de l'année précédante jusqu'au 30 juin de l'année en cours
	now = new Date();
	if (now.getMonth() >= 7){
		d = new Date(now.getFullYear(), 6, 1);
		f = new Date(now.getFullYear()+1, 5, 30);
	}
	else{
		d = new Date(now.getFullYear()-1, 6, 1);
		f = new Date(now.getFullYear(), 5, 30);		
	}

// à enlever
d = new Date(2012, 8, 1);
f = new Date(2012, 11, 30);
	
	// donne les valeurs par défaut aux controles de dates dans le filtre par date
	jQuery("#debut").datepicker({ defaultDate: d});
	jQuery("#fin").datepicker({ defaultDate: f});
	jQuery("#debut").val(d.toYMD());
	jQuery("#fin").val(f.toYMD());

	// gère le "afficher" et le "cacher" pour les boites de filtres
	jQuery(".showhide").on('click', function(){
		btn = jQuery(this);
		btn.parent().parent().find('ul').slideToggle();
		btn.html(btn.html() == 'Afficher' ? 'Cacher' : 'Afficher');
		btn.toggleClass('fermer');
	});


	// coche toutes les cases à cocher des auteurs quand l'utilisateur clique sur Tous les auteurs
	// coche la case Tous les auteurs si tous les auteurs sont effectivement cochés
	touslesauteurs = jQuery('#tousauteurs');
	auteursinput = jQuery('#auteurs li input');
	touslesauteurs.on('change', function(){
		auteursinput.attr('checked', touslesauteurs.is(':checked'));
	});
	auteursinput.on('change', function(){
		touslesauteurs.attr('checked', !(auteursinput.length > jQuery('#auteurs li input:checked').length));
	});


	// active les contrôles qui permettent de préciser les dates et de faire des regroupements si l'option Toutes les dates n'est pas cochée
	// désactive les mêmes contrôles si l'option Toutes les dates est cochée
	jQuery('#toutesdates').on('change', function(){
		if (jQuery('#toutesdates').is(':checked')){
			jQuery('#debut, #fin, #sansgroupe, #annuel, #mensuel, #hebdo').attr("disabled", "disabled");
			jQuery('#annuel').attr('selected', 'selected');
			jQuery('label[for=sansgroupe], label[for=annuel], label[for=mensuel], label[for=hebdo]').addClass("inactif");
		}
		else{
			jQuery('#debut, #fin, #sansgroupe, #annuel, #mensuel, #hebdo').removeAttr("disabled"); 
			jQuery('label[for=sansgroupe], label[for=annuel], label[for=mensuel], label[for=hebdo]').removeClass("inactif");
		}
	});

	// les boutons qui génèrent les statistiques dans les deux pages se font affecter leur fonction respective de génération
	if (updatename == 'updateStats'){
		jQuery('#updateStats').on('click', updateStats);	
	}
	else{
		jQuery('#updateLexique').on('click', updateLexique);
	}

}


/***********************************************************************************/
/* Fonction : 	sortXML                                                            */
/* Paramètres : x - le xml à trier                                                 */
/*				at - un attribut?                                                  */
/*				t1 - tag ou attribut à chercher                                    */
/*				t2 - le tag selon lequel on fait le tri                            */
/*				o - ordre (asc ou desc)                                            */
/*				dt - datatype (text ou number)                                     */
/* Retour : 	le xml dans un objet jQuery, trié                                  */
/* Rôle : 		trier un xml selon les paramètres                                  */
/***********************************************************************************/

function sortXML(x, t1, t2, o, dt){
	at = attr[t2]; 
	var o = (o == 'asc' ? -1 : 1);
	var r = jQuery(t1, x).sort(function(a, b){
		if (at != ''){
			if (dt == 'number'){
				var aa = parseInt(jQuery(a).find(t2).attr(at), 10);
				var bb = parseInt(jQuery(b).find(t2).attr(at), 10);
			}
			else{
				var aa = jQuery(a).find(t2).attr(at);
				var bb = jQuery(b).find(t2).attr(at);
			}
		}
		else{
			if (dt == 'number'){
				var aa = parseInt(jQuery(a).find(t2).text(), 10);
				var bb = parseInt(jQuery(b).find(t2).text(), 10);
			}
			else{
				var aa = jQuery(a).find(t2).text();
				var bb = jQuery(b).find(t2).text();
			}			
		}
		return aa > bb ? -1*o : 1*o;
	});	
	return r;
}


/***********************************************************************************/
/* Fonction : 	cleanText                                                          */
/* Paramètres : t - le texte à nettoyer                                            */
/* Retour : 	le texte nettoyé                                                   */
/* Rôle : 		remplacer tous les caractères spéciaux par un espace, entre autres */
/*              pour comparer les mots avec ceux du dictionnaire                   */
/***********************************************************************************/

function cleanText(t){
	return t.toLowerCase().replace(/[\*\^\'\!\@\\$\?\%\.\,\;\:\"\<\>\«\»\&\(\)\[\]\=\\\-\_\/0-9]/g, ' ')
}


/***********************************************************************************/
/* Fonction : 	toYMD                                                              */
/* Paramètres : aucun (s'utilise sur un objet date)                                */
/* Retour : 	la date dans une chaine de caractère de format AAAA-MM-JJ          */
/* Rôle : 		transformer la date au format d'affichage                          */
/***********************************************************************************/

Date.prototype.toYMD = function() {
    var dd =this.getDate();
    var m = this.getMonth() + 1;
    var y = this.getFullYear();
    return '' + y + '-' + (m<=9 ? '0' + m : m) + '-' + (dd <= 9 ? '0' + dd : dd);
}


/***********************************************************************************/
/* Fonction : 	getWeek                                                            */
/* Paramètres : aucun (s'utilise sur un objet date)                                */
/* Retour : 	le numéro de la semaine                                            */
/* Rôle : 		retourner la semaine de la date pour le filtre par semaine         */
/***********************************************************************************/

Date.prototype.getWeek = function() {
	var onejan = new Date(this.getFullYear(),0,1);
	return Math.ceil((((this - onejan) / 86400000) + onejan.getDay())/7);
}


/***********************************************************************************/
/* Fonction : 	getLundi                                                           */
/* Paramètres : aucun (s'utilise sur un objet date)                                */
/* Retour : 	le lundi de la semaine dans laquelle se trouve la date             */
/* Rôle : 		retourner le lundi de la semaine pour l'affichage dans le tableau  */
/***********************************************************************************/

Date.prototype.getLundi = function(){
	day = (this.getDay() == 0 ? 6 * 86400000 : (this.getDay()-1)*86400000);
	return new Date(this.getTime() - day);
}


